// laboratorium.m

#import "laboratorium.h"
#import "model.h"
#import <activity.h>
#import <simtoolsgui.h>

@implementation Laboratorium

+createBegin: aZone
{
  Laboratorium *obj;
  id <ProbeMap> probeMap;

  obj = [ super createBegin: aZone ];

  obj->displayFrequency = 1 ;

  probeMap = [ EmptyProbeMap createBegin: aZone ];
  [ probeMap setProbedClass: [ self class ] ];
  probeMap = [ probeMap createEnd ];

  [ probeMap addProbe: [ probeLibrary getProbeForVariable: "displayFrequency"
                       inClass: [self class] ] ];

  [ probeLibrary setProbeMap: probeMap For: [self class] ];


  return obj;
}

-createEnd
{
  return [ super createEnd ];
}

-buildObjects
{
  [ super buildObjects ];

  model = [ Model create: self ];

  CREATE_PROBE_DISPLAY(model);
  CREATE_PROBE_DISPLAY(self);
  printf("\nLaboratorium\n -frekvencia zobrazovania\n\n");
  printf("Model\n -worldXSize, worldYSize = velkost mriezky\n");
  printf(" -kolkoMravcov = pocet mravcov pobehujucich v mriezke\n\n");
  printf("!Tieto parametre sa pocas behu simulacie nedaju menit!\n");
  printf("\nPokracuj stlacenim STARTu na ovladacom paneli\n\n");

  [ controlPanel setStateStopped ];

  [ model buildObjects ];

  printf("Mravec\n -xPos, yPos = suradnice mravca");
  printf("\n -smer = smer, ktorym sa pohybuje mravec 0-hore 1-vpravo 2-dole 3-vlavo");
  printf("\n -gen = retazec pravidiel pohybu: L = odboc vlavo, R = odboc vpravo");
  printf("\n                                  F = neodbocuj  , B = otoc sa o 180 stupnov");
  printf("\n\nTieto parametre mozno menit v priebehu simulacie!\n");
  printf("Treba: zastavit simulaciu cez STOP, zmeneny parameter potvrdit ENTERom,\n pokracovat v simulacii stlacenim STARTu.\n");
  
  printf("\nPokracuj stlacenim STARTu na ovladacom paneli\n\n");

  [ controlPanel setStateStopped ];

  colorMap = [ Colormap create: self ];
  [colorMap setColor: 0 ToName: "white" ];
  [colorMap setColor: 1 ToName: "red" ];
  [colorMap setColor: 2 ToName: "pink" ];
  [colorMap setColor: 3 ToName: "blue" ];
  [colorMap setColor: 4 ToName: "yellow" ];
  [colorMap setColor: 5 ToName: "green" ];
  [colorMap setColor: 6 ToName: "magenta" ];
  [colorMap setColor: 7 ToName: "gray" ];
  [colorMap setColor: 8 ToName: "cyan" ];
  [colorMap setColor: 9 ToName: "black" ];

  worldRaster = [ ZoomRaster create: self ];
  [ worldRaster setColormap: colorMap ];
  [ worldRaster setZoomFactor: 4 ];
  [ worldRaster setWidth: [ [ model getWorld ] getSizeX ]
                  Height: [ [ model getWorld ] getSizeY ] ];
  [ worldRaster setWindowTitle: "Langtonov mravec" ];
  [ worldRaster pack ];

  feromonDisplay = [Value2dDisplay createBegin: self];
  [ feromonDisplay setDisplayWidget: worldRaster colormap: colorMap ];
  [ feromonDisplay setDiscrete2dToDisplay: [ model getFeromon ] ];
  feromonDisplay = [ feromonDisplay createEnd ];

  mravecDisplay = [ Object2dDisplay createBegin: self ];
  [ mravecDisplay setDisplayWidget: worldRaster ];
  [ mravecDisplay setDiscrete2dToDisplay: [ model getWorld ] ];
  [ mravecDisplay setObjectCollection: [ model getMravecList ] ];
  [ mravecDisplay setDisplayMessage: M(drawSelfOn:) ];
  mravecDisplay = [ mravecDisplay createEnd ];

  [ worldRaster setButton: ButtonRight
                Client: mravecDisplay
                Message: M(makeProbeAtX:Y:) ];


  return self;

}

-buildActions
{
  [ super buildActions ];
 
  [ model buildActions ];
  
  displayActions = [ ActionGroup create: self ];

  [ displayActions createActionTo: feromonDisplay message: M(display) ];
  [ displayActions createActionTo: mravecDisplay  message: M(display) ];
  [ displayActions createActionTo: worldRaster    message: M(drawSelf) ];

  [ displayActions createActionTo: actionCache    message: M(doTkEvents) ];
  [ displayActions createActionTo: probeDisplayManager message: M(update) ];

  displaySchedule = [ Schedule createBegin: self ];
  [displaySchedule setRepeatInterval: displayFrequency ];
  displaySchedule = [ displaySchedule createEnd ];
  [displaySchedule at: 0 createAction: displayActions ];

  return self;
}

-activateIn: swarmContext
{
  [ super activateIn: swarmContext ];
  
  [ model activateIn: self ];

  [ displaySchedule activateIn: self ];

  return [ self getSwarmActivity ];
}


@end