// model.m

#import "model.h"
#import <random.h>
#import <activity.h>
#import <collections.h>
#import <simtoolsgui.h>

@implementation Model
-getMravecList
{
  return mravecList;
}

-getWorld
{
  return world;
}

-getFeromon
{
  return feromon;
}

+createBegin: aZone
{
  Model *obj;

  id <ProbeMap> probeMap;

  obj = [ super createBegin: aZone ];

  obj -> worldXSize = 100 ;
  obj -> worldYSize = 100 ;
  obj -> seedProb = 0 ;
  obj -> kolkoMravcov = 1 ;

  probeMap = [ EmptyProbeMap createBegin: aZone ];
  [ probeMap setProbedClass: [ self class ] ];
  probeMap = [ probeMap createEnd ];

  [ probeMap addProbe: [ probeLibrary getProbeForVariable: "worldXSize"
                       inClass: [ self class ] ] ];  
  [ probeMap addProbe: [ probeLibrary getProbeForVariable: "worldYSize"
                       inClass: [ self class ] ] ];  
  [ probeMap addProbe: [ probeLibrary getProbeForVariable: "seedProb"
                       inClass: [ self class ] ] ];  
  [ probeMap addProbe: [ probeLibrary getProbeForVariable: "kolkoMravcov"
                       inClass: [ self class ] ] ];  

  [ probeLibrary setProbeMap: probeMap For: [ self class ] ];

  return obj ;

}

-createEnd
{
  return [ super createEnd ];
}



-buildObjects
{
  Mravec *aMravec;
  int x, y ;
  char *ret;

  feromon = [ FeromonSpace createBegin: self ];
  [ feromon setSizeX: worldXSize Y: worldYSize ];
  feromon = [ feromon createEnd ];

  [ feromon seedFeromonWithProb: seedProb ];

  world = [Grid2d createBegin: self];
  [world setSizeX: worldXSize Y: worldYSize ];
  world = [ world createEnd ];
  [ world fillWithObject: nil ];

  mravecList = [ List create: self ];

  for(x = 0 ; x < kolkoMravcov ; x++ ) 
  {
    aMravec = [ Mravec createBegin: self ];
    [ aMravec setWorld: world Feromon: feromon ];
    aMravec = [ aMravec createEnd ];

    ret=(char *)malloc(10*sizeof(char));
    ret[0]='L';
    ret[1]='R';
    ret[2]='\0';
    [ aMravec setX: 30*(x%2) Y: 30*((x+1)%2) S:1 ];
    [ aMravec setRet: ret ];
  
  
    CREATE_PROBE_DISPLAY(aMravec); 

    [ mravecList addLast: aMravec ];
  }

   return self;

}

-buildActions
{
  modelActions = [ ActionGroup create: self ];
  [ modelActions createActionForEach: mravecList message: M(step) ];

  modelSchedule = [ Schedule createBegin: self ];
  [ modelSchedule setRepeatInterval: 1 ];
  modelSchedule = [ modelSchedule createEnd ];
  [ modelSchedule at: 0 createAction: modelActions ];
 
  return self;

}

-activateIn: swarmContext
{
  [ super activateIn: swarmContext ];

  [ modelSchedule activateIn: self ];

  return [ self getSwarmActivity ];  

}

@end
